#!/bin/bash

#### Para criar o executavel do programa:
#chmod +x trablp.sh 
### Para rodar o programa:
#./trablp.sh -c in/clientes.csv -f in/fornecedores.csv -p in/produtos.csv -a in/compras.csv -v in/vendas.csv
#OBS: Baixar os arquivos testes e deixa-los na pasta in

cadastro_fornecedores()
{
	cont=0;
	
	#IFS=''
	while IFS=$'\n' read -r line || [[ -n "$line" ]]
	#while read line
	do  
		#echo $line
		if [ $cont != 0 ]
		then
			codigo_forn=(`echo $line | cut -d';' -f1`)
			nome=(`echo $line | cut -d';' -f2`)
			endereco=(`echo $line | cut -d';' -f3`)
			telefone=(`echo $line | cut -d';' -f4`)
			cnpj=(`echo $line | cut -d';' -f5`)
			contato=(`echo $line | cut -d';' -f6`)
			a_pagar=0
			subvet1=($codigo_forn $nome $endereco $telefone $cnpj $contato $a_pagar)
			#echo ${subvet1[*]};
		fi 
		let cont=$cont+1
		vetor_fornecedores+=( ${subvet1[*]} )
	done
}

cadastro_clientes()
{
	cont=0;
	IFS=''
	while IFS=$'\n' read -r line || [[ -n "$line" ]]
	#while read -r line
	#while IFS= read line
	do  
		if [ $cont != 0 ]
		then
			codigo_cliente=(`echo $line | cut -d';' -f1`)
			nome=(`echo $line | cut -d';' -f2`)
			endereco=(`echo $line | cut -d';' -f3`)
			telefone=(`echo $line | cut -d';' -f4`)
			data_cadastro=(`echo $line | cut -d';' -f5`)
			tipo_cliente=(`echo $line | cut -d';' -f6`)
			cpf=(`echo $line | cut -d';' -f7`)
			a_receber=0
			#echo $tipo
			if [ $tipo_cliente == "J" ] ; then insc=(`echo $line | cut -d';' -f8`) ; else insc=0 ; fi
			#echo $insc
			subvet2=($codigo_cliente $nome $endereco $telefone $data_cadastro $tipo_cliente $cpf $insc $a_receber)
			#echo ${subvet2[*]}
		fi 
		let cont=$cont+1
		vetor_clientes+=( ${subvet2[*]} )
	done
}

cadastro_produtos() #OBS: para valor so se aceita uma casa decimal ( valor= x,y )
{
	cont=0;

	while IFS=$'\n' read -r line || [[ -n "$line" ]]
	do  
		if [ $cont != 0 ]
		then
			codigo_prod=(`echo $line | cut -d';' -f1`)
			desc=(`echo $line | cut -d';' -f2`)
			estoque_min=(`echo $line | cut -d';' -f3`)
			estoque_atual=(`echo $line | cut -d';' -f4`)
			valor=(`echo $line | cut -d';' -f5`)
			valor2=(`echo $valor | cut -d',' -f1`)
			valor3=(`echo $valor | cut -d',' -f2`)
			valor4=(`echo $valor | cut -d',' -f3`)
			valor5=(`echo $valor | cut -d',' -f4`)
			if [ -e $valor4 ] ; then valor="$valor2.$valor3" ; else valor="$valor2.0" ; fi
			lucro=(`echo $line | cut -d';' -f6`)
			valor_venda=$(echo "scale=2; $valor+$valor*$lucro/100" | bc)
			#<valor de venda> = <valor de custo> + <valor de custo> * <percentual de lucro
			#echo $valor_venda
			subvet3=($codigo_prod $desc $estoque_min $estoque_atual $valor $lucro $valor_venda)
			#echo ${subvet3[*]}
		fi 
		let cont=$cont+1
		vetor_produtos+=( ${subvet3[*]} )
	done
}

registro_compras() #ao longo do mes valor=quantidade * valor produto
{
	cont=0;

	while IFS=$'\n' read -r line || [[ -n "$line" ]]
	do  
		if [ $cont != 0 ]
		then
			num_notaf=(`echo $line | cut -d';' -f1`)
			codigo_forn=(`echo $line | cut -d';' -f2`)
			data_compra=(`echo $line | cut -d';' -f3`)
			codigo_prod=(`echo $line | cut -d';' -f4`)
			quant=(`echo $line | cut -d';' -f5`)
			subvet4=($num_notaf $codigo_forn $data_compra $codigo_prod $quant)
			#echo ${subvet4[*]}
		fi 
		let cont=$cont+1
		vetor_compras+=( ${subvet4[*]} )
	done
}

registro_vendas() #ao longo do mes valor=quantidade * valor produto
{
	cont=0;

	while IFS=$'\n' read -r line || [[ -n "$line" ]]
	do  
		if [ $cont != 0 ]
		then
			codigo_cli=(`echo $line | cut -d';' -f1`)
			data_venda=(`echo $line | cut -d';' -f2`)
			codigo_prod=(`echo $line | cut -d';' -f3`)
			quant=(`echo $line | cut -d';' -f4`)
			modo_pagamento=(`echo $line | cut -d';' -f5`)
			subvet5=($codigo_cli $data_venda $codigo_prod $quant $modo_pagamento)
			#echo ${subvet5[*]}
		fi 
		let cont=$cont+1
		vetor_vendas+=( ${subvet5[*]} )
	done
}

Relatorio_Total_a_pagar()
{
	i=0
	while (( $i < ${#vetor_compras[*]} ))
	do
		#echo $k
		quant=${vetor_compras[$i+4]}
		prod=${vetor_compras[$i+3]}
		forn=${vetor_compras[$i+1]}
		
		l=0
		for j in ${vetor_produtos[*]}
		do
			if [ $j == "$prod" ]
			then 
				valor_prod=${vetor_produtos[$l+4]} 
				valor_prod2=$(echo "scale=2; $quant*$valor_prod" | bc)
			#	echo "$prod = ${vetor_produtos[$l+6]} * $quant = $valor_prod2"
				break 
			else let l=$l+1
			fi
		done

		a=0
		#echo ${#vetor_fornecedores[*]}
		while (( $a < ${#vetor_fornecedores_final[*]} ))
		do
			#echo ${vetor_fornecedores[a]} $forn
			if [ "${vetor_fornecedores_final[a]}" == "$forn" ]
			then 
			#	h=0
				#echo ${vetor_fornecedores[a]} $forn ${vetor_fornecedores[a+6]}
				vetor_fornecedores_final[a+6]=$(echo "scale=2; ${vetor_fornecedores_final[a+6]}+$valor_prod2" | bc)
			#	let b=$b+7
			fi
			let a=$a+7		
		done
	let i=$i+5
	#let k=$k+5
	done

	echo "Fornecedor;CNPJ;Pessoa de contato ;Telefone;Total a pagar" > 1-apagar.csv
 
	i=0
	while (( $i < ${#vetor_fornecedores_final[*]} ))
	do
		echo "${vetor_fornecedores_final[i+1]};${vetor_fornecedores_final[i+4]};${vetor_fornecedores_final[i+5]};${vetor_fornecedores_final[i+3]};R$ ${vetor_fornecedores_final[i+6]}" >> 1-apagar.csv 
		#echo "${vetor_fornecedores_final[i+1]};${vetor_fornecedores_final[i+4]};${vetor_fornecedores_final[i+5]};${vetor_fornecedores_final[i+3]};R$ ${vetor_fornecedores_final[i+6]}"
		let i=$i+7	
	done
}

Relatorio_Total_a_receber() #ao longo do mes valor=quantidade * valor produto
{
	k=0
	for i in ${vetor_vendas[*]}
	do
		if [ $i == "F" ]
		then 
			quant=${vetor_vendas[$k-1]}
			prod=${vetor_vendas[$k-2]}
			cliente=${vetor_vendas[$k-4]}
			j=0;l=0
			
			for j in ${vetor_produtos[*]}
			do
				if [ $j == "$prod" ]
				then 
					valor_prod=${vetor_produtos[$l+6]} 
					valor_prod2=$(echo "scale=2; $quant*$valor_prod" | bc)
					break 
				else let l=$l+1
				fi
			done

			b=0
			for a in ${vetor_clientes_final[*]}
			do
				if [ $a == "$cliente" ]
				then 
					vetor_clientes_final[b+8]=$(echo "scale=2; ${vetor_clientes_final[b+8]}+$valor_prod2" | bc)
				fi
				let b=$b+1		
			done
		let i=$i+5
		fi
		let k=$k+1
	done

	echo "Cliente;Tipo;CPF/CNPJ;Telefone;Data de cadastro;Total a pagar" > 2-areceber.csv 

	i=0
	while (( $i < ${#vetor_clientes_final[*]} ))
	do
		#let i=$i+9
		echo "${vetor_clientes_final[i+1]};${vetor_clientes_final[i+5]};${vetor_clientes_final[i+6]};${vetor_clientes_final[i+3]};${vetor_clientes_final[i+4]};R$ ${vetor_clientes_final[i+8]}" >> 2-areceber.csv
		#echo "${vetor_clientes_final[i+1]};${vetor_clientes_final[i+5]};${vetor_clientes_final[i+6]};${vetor_clientes_final[i+3]};${vetor_clientes_final[i+4]};R$ ${vetor_clientes_final[i+8]}"
		let i=$i+9
	done
}

############### ordenar vetor_fornecedores ###############	
ordenar_fornecedores()
{
	i=0
	while (( $i < ${#vetor_fornecedores[*]} ))
	do
		vetor_fornecedores_ord+=( ${vetor_fornecedores[i+1]} )
		let i=$i+7	
	done

	readarray -t sorted < <(for a in "${vetor_fornecedores_ord[@]}"; do echo "$a"; done | sort)

	l=0
	for i in ${sorted[@]}
	do
		for j in ${vetor_fornecedores[*]}
		do
			if [ $j == "$i" ]
			then
				vetor_fornecedores_final+=( ${vetor_fornecedores[l-1]} )
				vetor_fornecedores_final+=( ${vetor_fornecedores[l]} )
				vetor_fornecedores_final+=( ${vetor_fornecedores[l+1]} )
				vetor_fornecedores_final+=( ${vetor_fornecedores[l+2]} )
				vetor_fornecedores_final+=( ${vetor_fornecedores[l+3]} )
				vetor_fornecedores_final+=( ${vetor_fornecedores[l+4]} )
				vetor_fornecedores_final+=( ${vetor_fornecedores[l+5]} )
				l=0
				break 
			else let l=$l+1
			fi
		done
	done
}
########################################################

############### ordenar vetor_vendas ###############	
ordenar_vendas()
{
	#echo ${vetor_clientes[*]}
	while (( $i < ${#vetor_clientes[*]} ))
	do
		#echo ${vetor_clientes[i+1]}
		vetor_clientes_ord+=( ${vetor_clientes[i+1]} )
		let i=$i+9	
	done
	
	readarray -t sorted < <(for a in "${vetor_clientes_ord[@]}"; do echo "$a"; done | sort)

	l=0
	for i in ${sorted[@]}
	do
		for j in ${vetor_clientes[*]}
		do
			if [ $j == "$i" ]
			then
				vetor_clientes_final+=( ${vetor_clientes[l-1]} )
				vetor_clientes_final+=( ${vetor_clientes[l]} )
				vetor_clientes_final+=( ${vetor_clientes[l+1]} )
				vetor_clientes_final+=( ${vetor_clientes[l+2]} )
				vetor_clientes_final+=( ${vetor_clientes[l+3]} )
				vetor_clientes_final+=( ${vetor_clientes[l+4]} )
				vetor_clientes_final+=( ${vetor_clientes[l+5]} )
				vetor_clientes_final+=( ${vetor_clientes[l+6]} )
				vetor_clientes_final+=( ${vetor_clientes[l+7]} )
				l=0
				break 
			else let l=$l+1
			fi
		done
	done
}
########################################################

###################### MAIN ###########################

#-c <arquivo>: -f <arquivo>: -p <arquivo>: -a <arquivo>: -v <arquivo>:
if [ $1 = "-c" ] && [ $3 = "-f" ] && [ $5 = "-p" ] && [ $7 = "-a" ] && [ $9 = "-v" ] 
then 
	cadastro_clientes < $2; #echo
	cadastro_fornecedores < $4; #echo
	cadastro_produtos < $6; #echo
	ordenar_fornecedores
	ordenar_vendas
	registro_compras < $8; #echo
	registro_vendas < ${10}; #echo
	Relatorio_Total_a_pagar; #echo
	Relatorio_Total_a_receber
else
  echo "Entrada invalida"
fi
#######################################################


